aboutsummaryrefslogtreecommitdiffstats
path: root/target/linux/ar71xx/base-files/lib/upgrade
diff options
context:
space:
mode:
authorJohn Crispin <blogic@openwrt.org>2014-11-26 08:59:32 +0000
committerJohn Crispin <blogic@openwrt.org>2014-11-26 08:59:32 +0000
commitce4e6eb2e1aa82031d4369e7a40eacaca4691c6d (patch)
tree8c8c669b0e34f53474996c568a088c18c8bbfbd4 /target/linux/ar71xx/base-files/lib/upgrade
parentfe9456a922cc566c0349dee96808ab5e4f8263be (diff)
downloadmaster-187ad058-ce4e6eb2e1aa82031d4369e7a40eacaca4691c6d.tar.gz
master-187ad058-ce4e6eb2e1aa82031d4369e7a40eacaca4691c6d.tar.bz2
master-187ad058-ce4e6eb2e1aa82031d4369e7a40eacaca4691c6d.zip
ar71xx: add support for TP-LINK CPE210/220/510/520
This adds support for the TP-LINK CPE210/220/510/520 (Pharos series). These devices are very similar to the Ubiquiti NanoStations, but with better specs: faster CPU, more RAM, 2x2 MIMO. Signed-off-by: Matthias Schiffer <mschiffer@universe-factory.net> git-svn-id: svn://svn.openwrt.org/openwrt/trunk@43385 3c298f89-4303-0410-b956-a3cf2f4a3e73
Diffstat (limited to 'target/linux/ar71xx/base-files/lib/upgrade')
-rwxr-xr-xtarget/linux/ar71xx/base-files/lib/upgrade/platform.sh32
1 files changed, 32 insertions, 0 deletions
diff --git a/target/linux/ar71xx/base-files/lib/upgrade/platform.sh b/target/linux/ar71xx/base-files/lib/upgrade/platform.sh
index 598b33e79e..6a85d01df3 100755
--- a/target/linux/ar71xx/base-files/lib/upgrade/platform.sh
+++ b/target/linux/ar71xx/base-files/lib/upgrade/platform.sh
@@ -70,6 +70,33 @@ tplink_get_image_boot_size() {
get_image "$@" | dd bs=4 count=1 skip=37 2>/dev/null | hexdump -v -n 4 -e '1/1 "%02x"'
}
+tplink_pharos_check_image() {
+ local magic_long="$(get_magic_long "$1")"
+ [ "$magic_long" != "7f454c46" ] && {
+ echo "Invalid image magic '$magic_long'"
+ return 1
+ }
+
+ local model_string="$(tplink_pharos_get_model_string)"
+ local line
+
+ # Here $1 is given to dd directly instead of get_image as otherwise the skip
+ # will take almost a second (as dd can't seek then)
+ #
+ # This will fail if the image isn't local, but that's fine: as the
+ # read loop won't be executed at all, it will return true, so the image
+ # is accepted (loading the first 1.5M of a remote image for this check seems
+ # a bit extreme)
+ dd if="$1" bs=1 skip=1511432 count=1024 2>/dev/null | while read line; do
+ [ "$line" == "$model_string" ] && break
+ done || {
+ echo "Unsupported image (model not in support-list)"
+ return 1
+ }
+
+ return 0
+}
+
seama_get_type_magic() {
get_image "$@" | dd bs=1 count=4 skip=53 2>/dev/null | hexdump -v -n 4 -e '1/1 "%02x"'
}
@@ -217,6 +244,11 @@ platform_check_image() {
return 0
;;
+ cpe510)
+ tplink_pharos_check_image "$1" && return 0
+ return 1
+ ;;
+
dir-825-b1 | \
tew-673gru)
dir825b_check_image "$1" && return 0